/* ----------------------------------------------------------------------
 *
 * catalog.h 
 *
 * header file (catalog.c)
 *
 * Christoph C. Birk (birk@ociw.edu)
 *
 * ---------------------------------------------------------------------- */

#ifndef INCLUDE_CATALOG_H
#define INCLUDE_CATALOG_H

/* ---------------------------------------------------------------------- */

#ifdef IS_CATALOG_C
#define EXT_CAT
#else
#define EXT_CAT extern
#endif

/* INCLUDEs ------------------------------------------------------------- */

//#include  "kdcutil.h"
#include	KDCUTILH

/* DEFINEs --------------------------------------------------------------- */


/* TYPEDEFs ------------------------------------------------------------- */

typedef struct mapstar_tag {
  long   id;
/*  float  alpha,delta,mag; */
  float  mag;
  double alpha, delta;
  vect3  v;
  char   spc[8];
} CATstar;
/* Previously, alpha and delta were float */

enum   catalog_index { CAT_SAO,CAT_PPM,CAT_GSC,CAT_GSCP, 
                       CAT_USNO_SA,CAT_USNO_AO};

/* GLOBALs -------------------------------------------------------------- */

// EXT_CAT volatile int  catalog;
EXT_CAT int  catalog;

/* STATICs -------------------------------------------------------------- */

static double   cat_equ[]={1950.,2000.,2000.,2000.,2000.,2000.};
static float    cat_mag[]={12.,13.5,16.0,16.0,19.0,21.0};
/* Used in telmap.c (only) */

/* function prototype(s) ------------------------------------------------ */

char*  catpath		(void);

int    cat_open         (int);
void   cat_close        (void);

void   cat_ibound       (double,double,double,double,int*,int*,int*,int*);
void   cat_indices      (int,int,int*,int*);

int    GetSAO           (long,CATstar*,double);
int    GetGSC           (long,CATstar*);
int    GetPPM           (long,CATstar*);
int    GetUSNO_SA       (int,long,CATstar*);
int    GetUSNO_AO       (int,long,CATstar*);
int    GetGSCplus       (int,long,CATstar*);

char*  cat_name         (int cat_id);
char*  cat_create_name  (char*,int,long);

/* ---------------------------------------------------------------------- */

#endif  /* INCLUDE_CATALOG_H */

/* ---------------------------------------------------------------------- */
/* ---------------------------------------------------------------------- */
/* ---------------------------------------------------------------------- */

