/* ---------------------------------------------------------------------
 *
 * utils.h
 *
 * Project: GMAP  enhanced
 *
 * 2002-09-06  Ken Clardy, OCIW
 *
 * --------------------------------------------------------------------- */

#ifndef INCLUDE_DATUTIL_H
#define INCLUDE_DATUTIL_H

/* INCLUDES ------------------------------------------------------------ */

/* Should include maskdat.h? */
#include	MASKDATH
/* none */

/* DEFINES -------------------------------------------------------------- */

#ifndef  WHITESPACE
#define  WHITESPACE " \t"
// WHITESPACE is from ioutils.h
#endif

#define  AN  '\0'
/* Thus "AN" is ASCII NULL, a line terminating character */

/* TYPEDEFS ------------------------------------------------------------ */

/* datlist is defined in maskdat.h, now included
typedef  struct  datlist {
	struct datlist	*next;
	char	*data;
	} datlist;
					.. */
// the datlist is a simplified list of data text
// an alternate is kwlist, as follows

// typedef  struct  kwlist {
//	struct kwlist	*next;
//	char	*key;
//	char	*data;
//	} kwlist;

/* Structure(s) for the gmap ini data stuff... */
typedef  struct  section {
	struct section  *next, *last;
	char	*name;
	int	flag;		/* The default flag, maybe others */
	struct  datlist  *head;
	} section;

typedef  struct  gdata {
	struct  section  *telescope;
	struct  section  *camera;
	struct  section  *guider;
	} gdata;

/* In use, the current telescope, camera and guider section pointer
  will be determined first by the default flag read in from the 
  data file, and later by which is selected from the menu.  It will
  be stored in a global pointer to the appropriate section. */

/* The section pointer will be used as argument to get-keyword value
  subroutines.  It will initialize the datlist pointer from its head
  value, and the datlist will be searched for keywords in the same
  way that files are read in the "older" version of the program. */

/* FUNCTION PROTOTYPES ------------------------------------------------- */


/* First 2 are I/O subroutines to be moved when put into ioutils.c */

// char*	str_set (char* string, char* set);

void*  get_data (char* filespec, void* (*userprog)(char*, void*),
	char* delim,	char* leadcom,
	char* anycom,	char* dxcom,
	char* xdcom,	char* dxdcom );

/* Experimental file finding system; need main prototype */
void	findfile (char** spec, char* mode, char* name, char* dir);

/* These are the gmap specific programs.  First one is local, so
  is not included for real in prototype seciton */

// section*  newsection (char* name);

void*	gdatstore (char* line, void* head);


/* Finally, these are the replacement routines for those used
  in the older method... */

char*  get_gstring (section* sec, char* key, char* value, char* defstring);
long   get_glong   (section* sec, char* key, long defvalue);
double get_gdouble (section* sec, char* key, double defvalue);

/* Extended udp open is present here... */
int	udpopen_nb (int port);

/* --------------------------------------------------------------------- */
 
#endif  /* INCLUDE_DATUTIL_H */
 
/* --------------------------------------------------------------------- */
/* --------------------------------------------------------------------- */
